#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <assert.h>
#include "odicon.h"
#include "lseparable.h"


struct laminar_st *laminar;
static struct lseparable_st *lseparable_inst;
static double ffunc(int dim, double x[]) { return lseparable(dim, x, lseparable_inst); }
static double ifunc(int dim, int x[]) { return intint_func(dim, ffunc, x); }

static void read_param(int *init, struct lseparable_st *p) {
    if (!imatrix_scan(p->dim, p->aa)) return;
    if (!imatrix_scan(p->dim, p->bb)) return;
    if (!ivector_scan(p->dim, p->a)) return;
    if (!ivector_scan(p->dim, p->b)) return;
    if (!ivector_scan(p->dim, p->c)) return;
    if (!ivector_scan(p->dim, init)) return;
}

void demo_Lseparable(const int dim) {
    int init[1000];

    lseparable_inst = lseparable_make(dim);
    read_param(init, lseparable_inst);
    /* lseparable_output(lseparable_inst); */

    lgconv_minimize(dim, ifunc, init, 0);
}

void demo_Mseparable(const int dim) {
    int init[1000];

    lseparable_inst = lseparable_make(dim);
    read_param(init, lseparable_inst);
    /* lseparable_output(lseparable_inst); */

    mgconv_minimize(dim, ifunc, init);
}
